package com.brulijam.minecraftapi.service;

import com.brulijam.minecraftapi.model.Tutel;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

@Getter
@RequiredArgsConstructor
@Component
public class TutelService {

    private final List<Tutel> tutelList = new ArrayList<>();

    public void addToList(Tutel tutel) {
        tutelList.add(tutel);
    }

    public void removeById(long id) {
        Tutel tutel = tutelList.stream()
                .filter(turtle -> turtle.getId() == id)
                .findFirst()
                .orElse(null);
        tutelList.remove(tutel);
    }

    public Tutel getById(long id) {
        return tutelList.stream()
                .filter(tutel -> tutel.getId() == id)
                .findFirst()
                .orElse(null);
    }

    public Tutel getByLabel(String label) {
        return tutelList.stream()
                .filter(tutel -> tutel.getLabel().equals(label))
                .findFirst()
                .orElse(null);
    }
}
