package com.brulijam.minecraftapi.telegrambot;

import com.brulijam.minecraftapi.service.TelegramService;
import com.brulijam.minecraftapi.service.TutelService;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;
import org.telegram.telegrambots.bots.TelegramLongPollingBot;
import org.telegram.telegrambots.meta.api.methods.send.SendMessage;
import org.telegram.telegrambots.meta.api.objects.Update;
import org.telegram.telegrambots.meta.api.objects.User;
import org.telegram.telegrambots.meta.exceptions.TelegramApiException;

@Component
@RequiredArgsConstructor
@Getter
public class TelegramBot extends TelegramLongPollingBot {

    private final TutelService tutelService;
    private final TelegramService telegramService;

    @Value("${bot.name}")
    private String botUsername;
    @Value("${bot.token}")
    private String botToken;

    @Override
    public void onUpdateReceived(Update update) {

        if (update.hasMessage() && update.getMessage().hasText()) {
            User fromUser = update.getMessage().getFrom();

            String receivedMessage = update.getMessage().getText();

            handeleMessage(fromUser, receivedMessage);


        }
    }

    private void handeleMessage(User fromUser, String receivedMessage) {
        Long userId = fromUser.getId();

        if (receivedMessage.equals("/start")) {
            sendMessage(userId, "Your Telegram userId is " + userId);
        } else if (receivedMessage.equals("/list_tutels")) {
            if (userId == 5334468232L) {
                sendMessage(userId, "user is Brulijam");
                // send all tutels
                sendMessage(userId, tutelService.getTutelList().toString());
            } else {
                sendMessage(userId, "who are you?");
            }
        } else {
            sendMessage(userId, "huh?");
        }
    }

    @Override
    public String getBotUsername() {
        return botUsername;
    }

    @Override
    public String getBotToken() {
        return botToken;
    }

    public void sendMessage(Long chatId, String messageToSend) {
        SendMessage sendMessage = SendMessage.builder()
        .chatId(chatId.toString())
        .text(messageToSend)
        .build();

        try {
            execute(sendMessage);
        } catch (TelegramApiException e) {
            e.printStackTrace();
        }
    }
}
